/* aeb6r.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int aeb6r_c(integer *nm, integer *n, integer *m1, real *b,
        real *c__, real *ev, integer *l, integer *l0, real *v, real *z__, 
        real *w, logical *log__, integer *ierr)
{
    /* Initialized data */

    static real relmch = 5.9604645e-8f;

    /* Format strings */
    static char fmt_25[] = "";
    static char fmt_46[] = "";
    static char fmt_150[] = "";
    static char fmt_135[] = "";
    static char fmt_145[] = "";
    static char fmt_156[] = "";

    /* System generated locals */
    integer c_dim1, c_offset, b_dim1, b_offset, v_dim1, v_offset, w_dim1, 
            w_offset, log_dim1, log_offset, i__1, i__2, i__3, i__4;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    extern real av02r_c(real *, integer *), av04r_c(real *, real *, integer *);
    static real xmin, xmax;
    static integer ierr1;
    static real d__, f;
    static integer i__, j, k, m;
    static real r__, s, x;
    static integer j0, j1, j2, n1, i1, l1, m0;
    static real r1, s0, s1;
    static integer m01, m21, ki, li, mi, jk, it;
    static real sk;
    static integer li1, m2k, it0, ind, met;
    static real eps;
    static integer ind1, met1;
    static real eps2;

    /* Assigned format variables */
    static char *met_fmt, *met1_fmt;


#define b_ref(a_1,a_2) b[(a_2)*b_dim1 + a_1]
#define c___ref(a_1,a_2) c__[(a_2)*c_dim1 + a_1]
#define v_ref(a_1,a_2) v[(a_2)*v_dim1 + a_1]
#define w_ref(a_1,a_2) w[(a_2)*w_dim1 + a_1]
#define log___ref(a_1,a_2) log__[(a_2)*log_dim1 + a_1]

    /* Parameter adjustments */
    log_dim1 = *n;
    log_offset = log_dim1 + 1;
    log__ -= log_offset;
    w_dim1 = *n;
    w_offset = w_dim1 + 1;
    w -= w_offset;
    --z__;
    c_dim1 = *n;
    c_offset = c_dim1 + 1;
    c__ -= c_offset;
    b_dim1 = *nm;
    b_offset = b_dim1 + 1;
    b -= b_offset;
    v_dim1 = *nm;
    v_offset = v_dim1 + 1;
    v -= v_offset;
    --ev;

    /* Function Body */
    m = *m1 - 1;
    ierr1 = *ierr;
    met = 0;
    met_fmt = fmt_25;
    n1 = *n + 1;
    m21 = (m << 1) + 1;
    if (*n == 1) {
        v_ref(1, *l) = 1.f;
    }
    if (*n == 1) {
        goto L310;
    }
/*  OPM-E MACCBA C */
L1:
/*  C - KOMAKTHA OPMA  CXOHO MATP  A */
/*      /CTAH. OPMA  HECCMETP. EHTOHO  MATP/ */
    if (m == 0) {
        switch (met) {
            case 0: goto L25;
            case 1: goto L46;
        }
    }
    i__1 = m;
    for (j = 1; j <= i__1; ++j) {
        j0 = *m1 - j;
        j1 = j0 + 1;
        j2 = m21 + 1 - j;
        j1 = min(j1,*n);
        i__2 = *n;
        for (i__ = j1; i__ <= i__2; ++i__) {
            r__ = b_ref(i__, j);
            c___ref(i__, j) = r__;
            i1 = i__ - j0;
            c___ref(i1, j2) = r__;
/* L5: */
        }
        i__2 = j0;
        for (i__ = 1; i__ <= i__2; ++i__) {
            c___ref(i__, j) = 0.f;
            i1 = n1 - i__;
            c___ref(i1, j2) = 0.f;
/* L10: */
        }
/* L20: */
    }
    switch (met) {
        case 0: goto L25;
        case 1: goto L46;
    }
/*  B-E PAH EPOPHA  CXOHO MATP */
L25:
    xmax = b_ref(1, *m1);
    xmin = b_ref(1, *m1);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        s = 0.f;
        if (m == 0) {
            goto L35;
        }
        i__2 = m;
        for (j = 1; j <= i__2; ++j) {
            j1 = j + *m1;
            s = s + (r__1 = c___ref(i__, j), abs(r__1)) + (r__2 = c___ref(i__,
                     j1), abs(r__2));
/* L30: */
        }
L35:
/* Computing MAX */
        r__1 = xmax, r__2 = b_ref(i__, *m1) + s;
        xmax = max(r__1,r__2);
/* Computing MIN */
        r__1 = xmin, r__2 = b_ref(i__, *m1) - s;
        xmin = min(r__1,r__2);
/* L40: */
    }
/* Computing MAX */
    r__1 = abs(xmax), r__2 = abs(xmin);
    r__ = max(r__1,r__2);
    eps = r__ * relmch;
    if (eps == 0.f) {
        eps = relmch;
    }
    r1 = (real)sqrt(relmch);
    s = (real)sqrt(r1);
    eps2 = r__ * s;
    if (eps2 == 0.f) {
        eps2 = s;
    }
    met = 1;
    met_fmt = fmt_46;
/*   B-E C.B-POB */
    l1 = *l0 + 1;
    i__1 = *l;
    for (li = l1; li <= i__1; ++li) {
        x = ev[li];
        ind1 = 0;
        goto L1;
L46:
/*  C - KOMAKTHA OPMA  MATP  A - X*I */
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            c___ref(i__, *m1) = b_ref(i__, *m1) - x;
/* L50: */
        }
        if (m != 0) {
            goto L55;
        }
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            if ((r__1 = c___ref(i__, 1), abs(r__1)) < eps) {
                c___ref(i__, 1) = eps;
            }
/* L52: */
        }
        met1 = 0;
        met1_fmt = fmt_150;
        it = 0;
        ind = 0;
        goto L150;
L55:
        k = m;
        mi = *m1;
        i__2 = m;
        for (i__ = 1; i__ <= i__2; ++i__) {
            i__3 = m21;
            for (j = mi; j <= i__3; ++j) {
                jk = j - k;
                c___ref(i__, jk) = c___ref(i__, j);
/* L60: */
            }
            mi = k;
            --k;
            m2k = m21 - k;
            i__3 = m21;
            for (j = m2k; j <= i__3; ++j) {
                c___ref(i__, j) = 0.f;
/* L70: */
            }
/* L80: */
        }
/*  PBEEHE MATP  A - X*I  K BEPXHEMY TPEYOHOMY BY */
/*  METOOM AYCCA C EPECTAHOBKAM */
        if ((r__1 = c___ref(1, 1), abs(r__1)) < eps) {
            c___ref(1, 1) = eps;
        }
        i__2 = *n;
        for (k = 2; k <= i__2; ++k) {
/* Computing MIN */
            i__3 = m, i__4 = k - 1;
            m0 = min(i__3,i__4);
            m01 = m0 + 1;
            i__3 = m0;
            for (i1 = 1; i1 <= i__3; ++i1) {
                i__ = m01 - i1;
                ki = k - i__;
                log___ref(k, i__) = TRUE_;
                r__ = c___ref(k, 1);
                d__ = c___ref(ki, 1);
                if (abs(d__) > abs(r__)) {
                    goto L100;
                }
                if (r__ == 0.f) {
                    goto L110;
                }
                i__4 = m21;
                for (j = 1; j <= i__4; ++j) {
                    s = c___ref(k, j);
                    c___ref(k, j) = c___ref(ki, j);
                    c___ref(ki, j) = s;
/* L90: */
                }
                s = r__;
                r__ = d__;
                d__ = s;
                log___ref(k, i__) = FALSE_;
L100:
                s = r__ / d__;
                w_ref(k, i__) = s;
                i__4 = m21;
                for (j = 2; j <= i__4; ++j) {
                    c___ref(k, j - 1) = c___ref(k, j) - s * c___ref(ki, j);
/* L130: */
                }
                c___ref(k, m21) = 0.f;
L110:
                ;
            }
            if ((r__1 = c___ref(k, 1), abs(r__1)) < eps) {
                c___ref(k, 1) = eps;
            }
/* L120: */
        }
        ind = 0;
        met1 = 1;
        met1_fmt = fmt_135;
        if (ierr1 == 1) {
            met1 = 2;
            met1_fmt = fmt_145;
        }
L133:
        it = 0;
        switch (met1) {
            case 0: goto L150;
            case 1: goto L135;
            case 2: goto L145;
            case 3: goto L156;
        }
L135:
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            z__[i__] = eps;
/* L140: */
        }
        s0 = eps * *n;
        it0 = 1;
        met1 = 3;
        met1_fmt = fmt_156;
        goto L160;
L145:
        s0 = 0.f;
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            r__ = v_ref(i__, li);
            z__[i__] = r__;
            s0 += abs(r__);
/* L147: */
        }
        if (s0 <= relmch) {
            goto L135;
        }
        r__ = 1.f / s0;
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            z__[i__] *= r__;
/* L148: */
        }
        s0 = eps;
        it0 = 1;
        met1 = 1;
        goto L160;
L156:
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            z__[i__] = eps;
/* L157: */
        }
        s0 = eps * *n;
        it0 = 2;
        met1 = 0;
        met1_fmt = fmt_150;
        goto L205;
L150:
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
/* L152: */
            z__[i__] = 0.f;
        }
        it0 = 1;
        if (ind == *n && ind1 == m) {
            goto L290;
        }
        if (ind != *n) {
            goto L155;
        }
        ++ind1;
        x += eps;
        goto L1;
L155:
        ++ind;
        z__[ind] = eps;
        s0 = eps;
/* OPT- */
L160:
        li1 = li - 1;
        if (li1 == 0) {
            goto L159;
        }
        i__2 = li1;
        for (j1 = 1; j1 <= i__2; ++j1) {
            if ((r__1 = ev[j1] - x, abs(r__1)) > eps2) {
                goto L154;
            }
            r__ = (real)av04r_c(&v_ref(1, j1), &z__[1], n);
            i__3 = *n;
            for (i__ = 1; i__ <= i__3; ++i__) {
                z__[i__] -= r__ * v_ref(i__, j1);
/* L153: */
            }
L154:
            ;
        }
L159:
        s1 = 0.f;
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            s1 += (r__1 = z__[i__], abs(r__1));
/* L161: */
        }
        if (s1 <= s0 / (real) (*n)) {
            switch (met1) {
                case 0: goto L150;
                case 1: goto L135;
                case 2: goto L145;
                case 3: goto L156;
            }
        }
        sk = s1 / eps;
L165:
/* PMA OCTAHOBKA */
        if (m == 0) {
            goto L205;
        }
        i__2 = *n;
        for (k = 2; k <= i__2; ++k) {
/* Computing MIN */
            i__3 = m, i__4 = k - 1;
            m0 = min(i__3,i__4);
            m01 = m0 + 1;
            i__3 = m0;
            for (i1 = 1; i1 <= i__3; ++i1) {
                i__ = m01 - i1;
                ki = k - i__;
                if (log___ref(k, i__)) {
                    goto L180;
                }
                s = z__[k];
                z__[k] = z__[ki];
                z__[ki] = s;
L180:
                s = w_ref(k, i__);
                z__[k] -= s * z__[ki];
/* L190: */
            }
/* L200: */
        }
L205:
/* OPATHA OCTAHOBKA */
        i__2 = *n;
        for (i1 = 1; i1 <= i__2; ++i1) {
            i__ = n1 - i1;
            s = z__[i__];
            j0 = i__ - 1;
            j1 = min(i1,m21);
            if (j1 == 1) {
                goto L215;
            }
            i__3 = j1;
            for (j = 2; j <= i__3; ++j) {
                j2 = j + j0;
                s -= c___ref(i__, j) * z__[j2];
/* L210: */
            }
L215:
            z__[i__] = s / c___ref(i__, 1);
/* L220: */
        }
        ++it;
        li1 = li - 1;
        if (li1 == 0) {
            goto L270;
        }
        i__2 = li1;
        for (j1 = 1; j1 <= i__2; ++j1) {
            if ((r__1 = ev[j1] - x, abs(r__1)) > eps2) {
                goto L274;
            }
            r__ = (real)av04r_c(&v_ref(1, j1), &z__[1], n);
            i__3 = *n;
            for (i__ = 1; i__ <= i__3; ++i__) {
                z__[i__] -= r__ * v_ref(i__, j1);
/* L273: */
            }
L274:
            ;
        }
L270:
        s1 = 0.f;
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            s1 += (r__1 = z__[i__], abs(r__1));
/* L275: */
        }
        if (s1 > sk * .1f / *n && it >= it0) {
            goto L250;
        }
        if (s1 <= r1 || it == 2) {
            goto L133;
        }
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            z__[i__] = z__[i__] / s1 * eps;
/* L285: */
        }
        sk = 1.f;
        goto L165;
L290:
        *ierr = li;
        f = 0.f;
        goto L294;
L250:
        f = 1.f / (real)av02r_c(&z__[1], n);
L294:
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            v_ref(i__, li) = z__[i__] * f;
/* L295: */
        }
/* L300: */
    }
L310:
    return 0;
} /* aeb6r_c */

#undef log___ref
#undef w_ref
#undef v_ref
#undef c___ref
#undef b_ref
